After applying this patch and running configure, you MUST run this
command before "make":

    make proto


--- orig/io.c	2005-01-01 21:11:00
+++ io.c	2005-01-10 10:49:17
@@ -243,6 +243,14 @@ static void read_msg_fd(void)
 		read_loop(fd, buf, 4);
 		redo_list_add(IVAL(buf,0));
 		break;
+	case MSG_SUCCESS:
+		if (len != 4) {
+			rprintf(FERROR, "invalid message %d:%d\n", tag, len);
+			exit_cleanup(RERR_STREAMIO);
+		}
+		read_loop(fd, buf, len);
+		io_multiplex_write(MSG_SUCCESS, buf, len);
+		break;
 	case MSG_INFO:
 	case MSG_ERROR:
 	case MSG_LOG:
@@ -676,6 +684,16 @@ static int readfd_unbuffered(int fd, cha
 			read_loop(fd, iobuf_in, remaining);
 			iobuf_in_ndx = 0;
 			break;
+		case MSG_SUCCESS:
+			if (remaining != 4) {
+				rprintf(FERROR, "invalid multi-message %d:%ld\n",
+					tag, (long)remaining);
+				exit_cleanup(RERR_STREAMIO);
+			}
+			read_loop(fd, line, remaining);
+			successful_send(IVAL(line, 0));
+			remaining = 0;
+			break;
 		case MSG_INFO:
 		case MSG_ERROR:
 			if (remaining >= sizeof line) {
--- orig/main.c	2005-01-10 00:22:54
+++ main.c	2004-08-13 08:24:23
@@ -42,6 +42,7 @@ extern int list_only;
 extern int local_server;
 extern int log_got_error;
 extern int module_id;
+extern int need_messages_from_generator;
 extern int orig_umask;
 extern int copy_links;
 extern int keep_dirlinks;
@@ -647,6 +648,8 @@ void start_server(int f_in, int f_out, i
 
 	if (am_sender) {
 		keep_dirlinks = 0; /* Must be disabled on the sender. */
+		if (need_messages_from_generator)
+			io_start_multiplex_in();
 
 		recv_exclude_list(f_in);
 		if (cvs_exclude)
@@ -731,6 +734,9 @@ int client_run(int f_in, int f_out, pid_
 		exit_cleanup(status);
 	}
 
+	if (need_messages_from_generator && !read_batch)
+		io_start_multiplex_out();
+
 	if (argc == 0)
 		list_only = 1;
 
--- orig/options.c	2005-01-01 21:11:00
+++ options.c	2005-01-10 10:46:47
@@ -88,8 +88,10 @@ int daemon_bwlimit = 0;
 int bwlimit = 0;
 size_t bwlimit_writemax = 0;
 int delete_after = 0;
+int delete_sent_files = 0;
 int only_existing = 0;
 int opt_ignore_existing = 0;
+int need_messages_from_generator = 0;
 int max_delete = 0;
 OFF_T max_size = 0;
 int ignore_errors = 0;
@@ -273,6 +275,7 @@ void usage(enum logcode F)
   rprintf(F,"     --delete                delete files that don't exist on the sending side\n");
   rprintf(F,"     --delete-excluded       also delete excluded files on the receiving side\n");
   rprintf(F,"     --delete-after          receiver deletes after transferring, not before\n");
+  rprintf(F,"     --delete-sent-files     updated/sent files are removed from sending side\n");
   rprintf(F,"     --ignore-errors         delete even if there are I/O errors\n");
   rprintf(F,"     --max-delete=NUM        don't delete more than NUM files\n");
   rprintf(F,"     --max-size=SIZE         don't transfer any file larger than SIZE\n");
@@ -341,6 +344,7 @@ static struct poptOption long_options[] 
   {"ignore-existing",  0,  POPT_ARG_NONE,   &opt_ignore_existing, 0, 0, 0 },
   {"delete-after",     0,  POPT_ARG_NONE,   0, OPT_DELETE_AFTER, 0, 0 },
   {"delete-excluded",  0,  POPT_ARG_NONE,   0, OPT_DELETE_EXCLUDED, 0, 0 },
+  {"delete-sent-files",0,  POPT_ARG_NONE,   &delete_sent_files, 0, 0, 0 },
   {"force",            0,  POPT_ARG_NONE,   &force_delete, 0, 0, 0 },
   {"numeric-ids",      0,  POPT_ARG_NONE,   &numeric_ids, 0, 0, 0 },
   {"exclude",          0,  POPT_ARG_STRING, 0, OPT_EXCLUDE, 0, 0 },
@@ -854,6 +858,9 @@ int parse_arguments(int *argc, const cha
 	if (relative_paths < 0)
 		relative_paths = files_from? 1 : 0;
 
+	if (delete_sent_files)
+		need_messages_from_generator = 1;
+
 	*argv = poptGetArgs(pc);
 	*argc = count_args(*argv);
 
@@ -1240,6 +1247,9 @@ void server_options(char **args,int *arg
 			args[ac++] = "--no-relative";
 	}
 
+	if (delete_sent_files)
+		args[ac++] = "--delete-sent-files";
+
 	*argc = ac;
 	return;
 
--- orig/receiver.c	2005-01-10 09:46:01
+++ receiver.c	2004-08-13 08:38:51
@@ -46,6 +46,7 @@ extern char *backup_dir;
 extern char *backup_suffix;
 extern int backup_suffix_len;
 extern int cleanup_got_literal;
+extern int delete_sent_files;
 extern int module_id;
 extern int ignore_errors;
 extern int orig_umask;
@@ -342,7 +343,7 @@ int recv_files(int f_in, struct file_lis
 	char *fname, fbuf[MAXPATHLEN];
 	char template[MAXPATHLEN];
 	char fnametmp[MAXPATHLEN];
-	char *fnamecmp, *partialptr;
+	char *fnamecmp, *partialptr, numbuf[4];
 	char fnamecmpbuf[MAXPATHLEN];
 	struct file_struct *file;
 	struct stats initial_stats;
@@ -583,7 +584,12 @@ int recv_files(int f_in, struct file_lis
 
 		cleanup_disable();
 
-		if (!recv_ok) {
+		if (recv_ok) {
+			if (delete_sent_files) {
+				SIVAL(numbuf, 0, i);
+				send_msg(MSG_SUCCESS, numbuf, 4);
+			}
+		} else {
 			int msgtype = csum_length == SUM_LENGTH || read_batch ?
 				FERROR : FINFO;
 			if (msgtype == FERROR || verbose) {
@@ -607,9 +613,8 @@ int recv_files(int f_in, struct file_lis
 					keptstr, redostr);
 			}
 			if (csum_length != SUM_LENGTH) {
-				char buf[4];
-				SIVAL(buf, 0, i);
-				send_msg(MSG_REDO, buf, 4);
+				SIVAL(numbuf, 0, i);
+				send_msg(MSG_REDO, numbuf, 4);
 			}
 		}
 	}
--- orig/rsync.h	2005-01-10 00:21:12
+++ rsync.h	2004-07-03 20:17:10
@@ -60,6 +60,7 @@
 #define FLAG_TOP_DIR (1<<0)
 #define FLAG_HLINK_EOL (1<<1)	/* generator only */
 #define FLAG_MOUNT_POINT (1<<2)	/* sender only */
+#define FLAG_SENT (1<<7)	/* sender only */
 
 /* update this if you make incompatible changes */
 #define PROTOCOL_VERSION 28
@@ -134,6 +135,7 @@ enum logcode { FERROR=1, FINFO=2, FLOG=3
 /* Messages types that are sent over the message channel.  The logcode
  * values must all be present here with identical numbers. */
 enum msgcode {
+	MSG_SUCCESS=6,	/* successfully updated indicated flist index */
 	MSG_DONE=5,	/* current phase is done */
 	MSG_REDO=4,	/* reprocess indicated flist index */
 	MSG_ERROR=FERROR, MSG_INFO=FINFO, MSG_LOG=FLOG, /* remote logging */
--- orig/rsync.yo	2005-01-01 21:11:01
+++ rsync.yo	2004-07-03 20:17:10
@@ -343,6 +343,7 @@ verb(
      --delete                delete files that don't exist on sender
      --delete-excluded       also delete excluded files on receiver
      --delete-after          receiver deletes after transfer, not before
+     --delete-sent-files     updated/sent files are removed from sender
      --ignore-errors         delete even if there are I/O errors
      --max-delete=NUM        don't delete more than NUM files
      --max-size=SIZE         don't transfer any file larger than SIZE
@@ -684,6 +685,11 @@ receiving side before transferring files
 sufficient space on the receiving filesystem. If you want to delete
 after transferring, use the --delete-after switch. Implies --delete.
 
+dit(bf(--delete-sent-files)) This tells rsync to remove the source files
+on the sending side that are successfully transferred to the receiving
+side.  Directories are not removed, nor are files that are identical on
+both systems.
+
 dit(bf(--ignore-errors)) Tells --delete to go ahead and delete files
 even when there are I/O errors.
 
--- orig/sender.c	2005-01-01 21:11:01
+++ sender.c	2004-07-26 16:49:19
@@ -26,6 +26,7 @@ extern int io_error;
 extern int dry_run;
 extern int am_server;
 extern int am_daemon;
+extern int delete_sent_files;
 extern int protocol_version;
 extern int make_backups;
 extern struct stats stats;
@@ -108,7 +109,29 @@ static struct sum_struct *receive_sums(i
 	return s;
 }
 
+static struct file_list *the_flist;
 
+void successful_send(int i)
+{
+	char fname[MAXPATHLEN];
+	struct file_struct *file;
+	unsigned int offset;
+
+	if (!the_flist || i < 0 || i >= the_flist->count)
+		return;
+
+	file = the_flist->files[i];
+	if (!(file->flags & FLAG_SENT))
+		return; /* We didn't send it -- impossible! */
+	if (file->basedir) {
+		offset = stringjoin(fname, sizeof fname,
+				    file->basedir, "/", NULL);
+	} else
+		offset = 0;
+	f_name_to(file, fname + offset);
+	if (delete_sent_files && do_unlink(fname) == 0 && verbose > 0)
+		rprintf(FINFO, "sender removed %s\n", fname + offset);
+}
 
 void send_files(struct file_list *flist, int f_out, int f_in)
 {
@@ -127,6 +150,8 @@ void send_files(struct file_list *flist,
 	if (verbose > 2)
 		rprintf(FINFO, "send_files starting\n");
 
+	the_flist = flist;
+
 	while (1) {
 		unsigned int offset;
 
@@ -257,6 +282,9 @@ void send_files(struct file_list *flist,
 			rprintf(FINFO, "sender finished %s\n",
 				safe_fname(fname));
 		}
+
+		/* Flag that we actually sent this entry. */
+		file->flags |= FLAG_SENT;
 	}
 	make_backups = save_make_backups;
 
